--create the BSFManager
BSF = .BSFManager~new

--create all those "java"-classes
BSF~import('awtButton'    , 'java.awt.Button'    )
BSF~import('awtChoice'    , 'java.awt.Choice'    )
BSF~import('awtColor'     , 'java.awt.Color'     )
BSF~import('awtFrame'     , 'java.awt.Frame'     )
BSF~import('awtGridLayout', 'java.awt.GridLayout')
BSF~import('awtLabel'     , 'java.awt.Label'     )
BSF~import('awtTextField' , 'java.awt.TextField' )

--create 3 labels
Label1 = .awtLabel~new('S', 'Gender: ')
Label2 = .awtLabel~new('S', 'First Name: ')
Label3 = .awtLabel~new('S', 'Surname: ')

--create a drop down list with 2 entries
DropDown = .awtChoice~new
DropDown~~addItem('S', 'male')~~addItem('S', 'female')

--create 2 textfields
Surname = .awtTextField~new
Name    = .awtTextField~new

--create myDir for use with the Greetings routine
myDir=.directory~new
myDir~DropDown = DropDown;
myDir~Surname  = Surname;
myDir~Name     = Name;

--create 2 buttons and add events to them
OK     = .awtButton~new('S', 'OK')
Cancel = .awtButton~new('S', 'Cancel')
OK~event('action', '', 'call Greetings myDir')
Cancel~event('action', '', 'BSF~exit')

--set the window layout
Background = .awtColor~new('I', 150, 'I', 150, 'I', 250)
GLayout    = .awtGridLayout~new('I', 4, 'I', 2)
Window     = .awtFrame~new('S', 'Greetings!')
Window~event('window', 'windowClosing', 'BSF~exit')

--add all the elements to the window
Window~setLayout('O', GLayout)
Window~~add('O', Label1)~~add('O', DropDown)
Window~~add('O', Label2)~~add('O', Name)
Window~~add('O', Label3)~~add('O', Surname)
Window~~add('O', OK)~~add('O', Cancel)
Window~setSize('I', 200, 'I', 200)
Window~setBackground('O', Background)
Window~~pack~~show~~toFront

--run the event loop
do forever
  interpret PollBSFEvents()
end

exit

::REQUIRES BSFEngine.rex

--open up a new window and greet the user
::ROUTINE Greetings
use arg mydir
Window2 = .awtFrame~new
Window2~event('window', 'windowClosing', 'BSF~exit')
Greet = .awtLabel~new
Bye = .awtButton~new('S', 'Bye!')
Bye~event('action', '', 'BSF~exit')

Window2~~add('S', 'North', 'O', Greet)~~add('S', 'South', 'O', Bye)
Window2~~pack~~show~~toFront

Gender = myDir~DropDown~getSelectedItem
N1 = myDir~Name~getText
N2 = myDir~Surname~getText
if Gender=="male" then Greet~setText('S', 'Hello Mr.' N1 N2)
else Greet~setText('S', 'Hello Mrs.' N1 N2)
return