/* $Id: ScriptSymbolTable.java,v 1.1.1.1 2000/06/20 19:19:25 samruby Exp $ */

package com.ibm.cs.util;

import java.util.Hashtable;

/**
 * An <code>ScriptSymbolTable</code> object is used by a <code>CodeBuffer</code>
 * object to implement nested scopes.
 * 
 * @version  $Revision: 1.1.1.1 $
 * @author   Matthew J. Duftler
 */
class ScriptSymbolTable extends Hashtable
{
	private Hashtable parentTable;

	ScriptSymbolTable(Hashtable parentTable)
  {
  	this.parentTable = parentTable;
  }

  public synchronized Object get(Object key)
  {
  	Object ret = super.get(key);

  	if (ret == null && parentTable != null)
  	  ret = parentTable.get(key);

  	return ret;
  }
}